#include <libtools.h>
#include <anymap.h>
#include <thread>

typedef std::function<int(com::Anymap)> IntFunc;
typedef std::function<bool(com::Anymap)> BoolFunc;
typedef std::function<bool*(com::Anymap)> BoolArrFunc;  

IntFunc LoadEntry(std::string lib, std::string func) {
    DllHandle handler;
    return com::lib::loadFunction<int (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

BoolFunc LoadPred(std::string lib, std::string func) {
    DllHandle handler;
    return com::lib::loadFunction<int (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

BoolArrFunc LoadSelector(std::string lib, std::string func){
    DllHandle handler;
    return com::lib::loadFunction<bool* (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

int main(int argc, char const *argv[])
{
    std::list<void*> selectors;
    bool* ST1_sel_val, ST2_sel_val;
    int NODE_counter;
    auto data = com::Anymap();
    auto predFunc = LoadPred("libprinters", "ReturnTrue"); 
    auto entrFunc = LoadEntry("libprinters", "PrintHello");
    auto selector = LoadSelector("libprinters", "ThreeTrue");
    if (!predFunc(data)) {
        std::cout<<"Predicate returned FALSE on state ${}\n"; 
        goto TERM;
    }
    entrFunc(data);

int S_6_incomes=0,
    S_8_incomes=0;
bool S_6_exec = false,
     S_8_exec = false;

S_1:
int i = 0;
auto SEL_S_1 = selector(data);
if (SEL_S_1[0]) {
    libcomsdk_pass_predicate();
    libgcdfes_fem_task_loader();
    libcomsdk_pass_predicate();
    libgcdfes_fe_mesh_loader();
}
if (SEL_S_1[1]) {
    libcomsdk_pass_predicate();
    libgcdfes_sld_data_loader();
    libcomsdk_pass_predicate();
    libcomsdk_pass_processor();
}
S_6_exec = SEL_S_1[0] || SEL_S_1[1];
if (S_6_exec) {
    libcomsdk_pass_predicate();
    libgcdfes_fe_type_loader();
    libcomsdk_pass_predicate();
    libcomsdk_pass_processor();
}
if (SEL_S_1[2]) {
    libcomsdk_pass_predicate();
    libgcdfes_bc_loader();
    libcomsdk_pass_predicate();
    libcomsdk_pass_processor();
}
if (SEL_S_1[3]){
    libcomsdk_pass_predicate();
    libgcdfes_computation_prepare();
    libcomsdk_pass_predicate();
    libcomsdk_pass_processor();
}
S_8_exec =  S_6_exec || SEL_S_1[0] || SEL_S_1[1];
if (S_8_exec) {
    auto SEL_S_8 = selector(data);
    if (SEL_S_8[0]) {
        goto ST1;
    }
    if (SEL_S_8[1]) {
        goto TERM;
    }
}

//
libcomsdk_None(data); 
libgcdfes_las_fem_cslr_loader(data);
SEL___BEGIN__[0] = true;
if (!(false || SEL___BEGIN__[0] || SEL_S_2[0] ))
{
    for (int seli = 0; seli < 2; seli ++)
        SEL_S_2[seli] = false;
}
S_2:
if (SEL_S_2[0])
{
    libcomsdk_None(data);
    libgcdfes_las_fem_cslr_assemble(data);
    goto S_2;
}
if (SEL_S_2[1])
{
    libcomsdk_None(data);
    libgcdfes_las_fem_cslr_bc_apply(data);
}
if (!(false || SEL_S_2[1] || SEL_S_3[0] ))
{
    for (int seli = 0; seli < 2; seli ++)
        SEL_S_3[seli] = false;
}
S_3:
if (SEL_S_3[0])
{
        libcomsdk_None(data);
        libgcdfes_las_eqn_cg_cslr_precond(data);
        goto S_3;
}
if (SEL_S_3[1])
{
        libcomsdk_None(data);
        libgcdfes_las_eqn_cg_cslr_solver(data);
        libcomsdk_None(data);
        libgcdfes_las_eqn_cg_cslr_prepare(data);
        libcomsdk_None(data);
        libgcdfes_las_eqn_cg_cslr_postproc(data);
}
libcomsdk_None(data);
libgcdfes_las_eqn_cg_cslr_precond(data);
SEL_S_6[0] = true;
libcomsdk_None(data);
libgcdfes_las_eqn_cg_cslr_solver(data);
SEL_S_6[1] = true;
if (!(false || SEL_S_6[0] || SEL_S_6[1] ))
{
    goto TERM;
}

TERM:
    std::cout<<"Termination!\n"; 
    return 0;
}